var APIBase = require("../../api.base");
var system = require("../../../system");
var settings = require("../../../../config/settings");
const uuidv4 = require('uuid/v4');
/**
 * icp通知接口（百度icp接入）
 * 庄冰 2020.10.22
 */
class Order extends APIBase {
    constructor() {
        super();
        this.gatewaypushlogSve = system.getObject("service.common.gatewaypushlogSve");
    }

    getUUID() {
        var uuid = uuidv4();
        var u = uuid.replace(/\-/g, "");
        return u;
    }
    getResultSuccess(requestId) {
        return {
        "status": 0,
        "msg": "success",
        "data":null,
        "requestId": requestId
        };
    }
    getResultFail(errmsg) {
        var self = this;
        return {
        "status":-1,
        "msg": errmsg,
        "requestId": self.getUUID(),
        "data":null,
        "bizmsg":"empty"
        };
    }

    
    //icp状态变更
    async notify(pobj,obj,req) {
        var self = this;
        if(!pobj.appInfo || !pobj.appInfo.uapp_key || !pobj.appInfo.uapp_secret){
            return self.getResultFail("未知应用或应用未启用");
        }
        if (!pobj.orderNo) {
            return self.getResultFail("orderNo不能为空");
        }
        if(!pobj.isDirectBuy || pobj.isDirectBuy=="0"){
            pobj.isDirectBuy=0;
        }
        pobj.status = 1;
        if (pobj.isDirectBuy==0 && !pobj.bizId) {
            return self.getResultFail("非直接下单bizId不能为空");
        }
        if (pobj.isDirectBuy==1 && !pobj.phone) {
            return self.getResultFail("直接下单phone不能为空");
        }
        if (pobj.isDirectBuy==1 && !pobj.consultType) {
            return self.getResultFail("直接下单consultType不能为空");
        }else{
            if (pobj.consultType=="ICP") {
                pobj.consultType="5";
            }
            if (pobj.consultType=="EDI") {
                pobj.consultType="7";
            }
        }
        pobj.action_type = "icpOrderStatus";
        var param = {
            requestId: req.requestId || self.getUUID(),
            requestUrl: "/icp/order/notify",
            requestjson: JSON.stringify(pobj),//请求地址
            pushUrl: "/action/intentionapi/springBoard",//调用地址
            pushActionType: "icpNotifyNew",//调用参数
            pushtimes: 0,//推送次数
            pushStatus: "wts",//推送状态
        }
        await self.gatewaypushlogSve.create(param);
        return self.getResultSuccess(param.requestId);
    }

}
module.exports = Order;