var APIBase = require("../../api.base");
var system = require("../../../system");
var settings = require("../../../../config/settings");
class edi extends APIBase {
  constructor() {
    super();
    this.centerorderSve = system.getObject("service.common.centerorderSve");
    this.utilsOrderSve = system.getObject("service.utilsSve.utilsOrderSve");
    this.utilsNeedSve = system.getObject("service.utilsSve.utilsNeedSve");
    this.utilsServicedSve = system.getObject("service.utilsSve.utilsServiceSve");
  }

  /**
    * 接口跳转-POST请求
    * action_process  执行的流程
    * action_type     执行的类型
    * action_body     执行的参数
    */
  async springBoard(pobj, qobj, req) {
    if (!pobj.actionType) {
      return system.getResult(null, "actionType参数不能为空");
    }
    var result = await this.opActionProcess(pobj, pobj.actionType, pobj.actionBody, req);
    return result;
  }
  async opActionProcess(pobj, action_type, action_body, req) {
    var opResult = null;
    switch (action_type) {
      case "submitService":
        opResult = await this.utilsServicedSve.submitService(pobj, pobj.actionBody);
        break;
      default:
        opResult = system.getResult(null, "action_type参数错误");
        break;
    }
    return opResult;
  }

}
module.exports = edi;